(function maxPairs(data) {
    const maxPairCount = 4;
    // case: config without pairs, allow adding pairs
    if (typeof data.config.pairs?.binance === 'undefined'){
        return maxPairCount + 7;
    }
    const configPairCount = Object.keys(data.config.pairs.binance).length;
    let haveInactivePair = JSON.stringify(data.config.pairs.binance).includes('inactive');
    // case: less than maxPairCount in config, allow adding new pairs 
    if (configPairCount < maxPairCount) {
        return maxPairCount + 7;
    }
    // case: maxPairCount is reached but one or more pairs are inactive, allow adding new pairs
    else if (configPairCount === maxPairCount && haveInactivePair) {
        return maxPairCount + 7;
    }
    // case: maxPairCount is reached without having inactive pairs, don't allow adding new pairs
    else if (configPairCount === maxPairCount && !haveInactivePair) {
        return maxPairCount;
    }
    // case: all slots full and/or already evaluating new pairs to trade, don't add additional pairs
    else if (configPairCount > maxPairCount) {
        return maxPairCount;
    }
})(this)