// most code is just needed to make sure this only works when all relevant pairs have cycled
(function rankNewPairs(data) {
	// function ranks all pairs with status 'new', return value is compared to number of free slots in the handleOverrides function
	const base = data.pairName.split('-')[0];
	let configSameBasePairCount = 0;
	let sameBasePairs = [];
	let maxSameBase = 0;
	const checkTrend = function (trendData, pair) {
		const overrides = data.config.pairs.binance[pair].override
		const useTrendSync = overrides?.TREND_SYNC || false;
		const volatilityMode = overrides?.VOLATILITY_MODE || false;
		const pullbackMode = overrides?.PULLBACK_MODE || false;
        const taMode = overrides?.TA_MODE || false;
		const useCustomTradingRangeMode = overrides?.CUSTOM_TRADING_RANGE_MODE || false;
		const testActiveCustomRangePairs = (element) => data.config.pairs.binance[element]?.override?.STATUS === 'active' && data.config.pairs.binance[element]?.override?.CUSTOM_TRADING_RANGE_MODE && data.config.pairs.binance[element]?.override?.BAG_SIZE !== 'none'
		const hasActiveCustomRangePairs = Object.keys(data.config.pairs.binance).some(testActiveCustomRangePairs)
        if (volatilityMode && trendData.structure && trendData.volatilityBuy4h && !trendData.doNotOpen) {
			if (!useTrendSync) {
				return true
			}
			else {
				return trendData?.structureSync || false;
			}
		}
		else if (taMode && trendData?.taFractals) {
			if (!useTrendSync) {
				return true
			}
			else {
				return trendData?.structureSync || false;
			}
		}
		else if (pullbackMode && trendData?.pullback4h) {
			if (!useTrendSync) {
				return true
			}
			else {
				return trendData?.structureSync || false;
			}
		}
		else if (useCustomTradingRangeMode && trendData?.structure && trendData?.structureSync && trendData?.tlr > 0.5 && trendData?.exitTrail === false && !hasActiveCustomRangePairs) {
			return true
		}
    } 
	
	Object.keys(data.config.pairs.binance).forEach((pair => {
		if (pair.split('-')[0] === base) {
			configSameBasePairCount++;
			sameBasePairs.push(pair)
		}
		if (maxSameBase === 0) {
            maxSameBase = parseFloat(data.config.pairs.binance[pair].override.MAX_PAIR_PER_BASE)
        }
	}));
	let positionSameBase = [];
	let newPairs = [];
	let greatNewPairs = []
	let activePairCount = 0;
	sameBasePairs.forEach((pair => {
		if (data.config.pairs?.binance?.[pair]?.override?.STATUS === 'active' || data.pairVariables.binance?.[pair]?.newOverrides?.STATUS === 'active') {
                activePairCount++;
            }
		if (Object.keys(data.pairVariables.binance).indexOf(pair) > -1) {
			if (parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.BAG_SIZE) > 0) {
				positionSameBase.push(parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.BAG_SIZE));
			} 
			else if (data.pairVariables.binance?.[pair]?.newOverrides?.BAG_SIZE === 'none') {
				positionSameBase.push(0);
			}
			if (data.pairVariables.binance?.[pair]?.newOverrides?.STATUS === 'new' && checkTrend(data.pairVariables.binance?.[pair]?.newOverrides?.trendData, pair) && data.pairVariables.binance?.[pair]?.newOverrides?.trendData?.doNotOpen === false) {
				newPairs.push(pair);
			}
			else if (data.pairVariables.binance?.[pair]?.newOverrides?.STATUS === 'new' && checkTrend(data.pairVariables.binance?.[pair]?.newOverrides?.trendData, pair)) {
				greatNewPairs.push(pair);
			}
		}
	}));
	const resultPairs = [...greatNewPairs, ...newPairs]
	const result = resultPairs.indexOf(data.pairName) > -1 ? resultPairs.indexOf(data.pairName) + 1 : -2
	// failsafe, should prevent cases where a pair gets ranked again very shortly after others got activated but haven't traded yet

	if (activePairCount >= maxSameBase){
		return -2
	}

	// only return rank when all pairs of same base have cycled and generated data
	if (positionSameBase.length === configSameBasePairCount && 
		data.pairVariables.binance?.[data.pairName]?.newOverrides?.STATUS === 'new' && 
		data.pairVariables.binance?.[data.pairName]?.newOverrides?.RANKING_RESULT !== -2) {
        // return pair rank, set -2 when no rank exists
		return result
	} 
	else {
		return -1;
	}
})(this)