// most code is just needed to make sure this only works when all relevant pairs have cycled
(function deactivateWorstPair(data) {
    // function ranks active trading pairs that have been trading for at least 12h, makes sure the worst performing pairs gets STOP_AFTER_SELL
    const base = data.pairName.split('-')[0];
    let configPairCount = 0;
    let sameBasePairs = [];
    let maxSameBase = 0;
    Object.keys(data.config.pairs.binance).forEach((pair => {
        if (pair.split('-')[0] === base) {
            configPairCount++;
            sameBasePairs.push(pair)
        }
        if (maxSameBase === 0) {
            maxSameBase = parseFloat(data.config.pairs.binance[pair].override.MAX_PAIR_PER_BASE)
        }
    }));
    let positions = [];
    let activePairCount = 0;
    let activePairCountWithoutRankingCheck = 0
    let worstPairStats = 0;
    let worstPairName = '';
    let leastDrawdown = 999
    let leastDrawdownPairName = ''
    sameBasePairs.forEach((pair => {
        if (Object.keys(data.pairVariables.binance).indexOf(pair) > -1) {
            if (parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.BAG_SIZE) > 0) {
                positions.push(parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.BAG_SIZE));
            } else if (data.pairVariables.binance?.[pair]?.newOverrides?.BAG_SIZE === 'none') {
                positions.push(0);
            }
            // count pairs as active when they have status active and have traded long enough to gather ranking stats OR when they have just been panic sold
            if ((data.pairVariables.binance?.[pair]?.newOverrides?.STATUS === 'active' &&
                parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.RANKING_TRADE_COUNT) > -1 &&
                parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.RANKING_PNL) > -1) ||
                data.pairVariables.binance?.[pair]?.newOverrides?.PANIC_SELL) {
                activePairCount++;
            }
            // additional counter that disregards available stats, only used for handling a case where there are more active pairs than allowed
            if (data.pairVariables.binance?.[pair]?.newOverrides?.STATUS === 'active') {
                activePairCountWithoutRankingCheck++;
        }
        }
    }));

    // figure out worst performing pair, can only happen if all active pairs have been added more than 12h ago
    sameBasePairs.forEach((pair => {

        let howManyTL
        if (data.pairVariables.binance?.[pair]?.newOverrides?.BAG_SIZE === 'none') {
            howManyTL = 0
        }
        else {
            howManyTL = Math.round(parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.BAG_SIZE) / parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.TRADING_LIMIT))
        }

        // save current smallest bag, to get rid of in case active pair count exceeds allowed maximum
        if (howManyTL < leastDrawdown){
            leastDrawdown = howManyTL
            leastDrawdownPairName = pair
        }

        // ranking for pairs that ran for 12h 
        if (parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.RANKING_TRADE_COUNT) > -1 && parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.RANKING_PNL) > -1 && activePairCount >= maxSameBase) {

            // available stats
            const pnl = parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.RANKING_PNL)
            const sellCount = parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.RANKING_TRADE_COUNT)
            const biggestBag = parseFloat(data.pairVariables.binance?.[pair]?.newOverrides?.BAG_BIGGEST)

            // ranking factors
            const pnlFactor = pnl / sellCount
            const activityFactor = sellCount === 0 ? 1 : sellCount
            const drawdownFactor = biggestBag / activityFactor

            // ranking result
            const pairStats = (pnlFactor + activityFactor) - drawdownFactor

            if (worstPairStats === 0) {
                worstPairName = pair;
                worstPairStats = pairStats;
            } else if (pairStats < worstPairStats) {
                worstPairName = pair;
                worstPairStats = pairStats;
            }

        }
    }));
    if (activePairCount >= 2 && data.config.pairs.binance[data.pairName].override?.BUY_METHOD === 'gain' && data.config.pairs.binance[data.pairName].override?.PANIC_SELL && data.config.pairs.binance[data.pairName].override?.BAG_VALUE === 'none'){
        // catch a case where pair should have been removed already
        return true
    }
    else if (positions.length === configPairCount && activePairCount >= maxSameBase && data.pairName === worstPairName) {
        // set STOP_AFTER_SELL true for worst pair
        return true;
    }
    else if (positions.length === configPairCount && activePairCountWithoutRankingCheck > maxSameBase && data.pairName === leastDrawdownPairName) {
        // set STOP_AFTER_SELL true for pair with smallest bag, only in case active pair count exceeds allowed maximum
        console.log('setting stop after sell for', data.pairName)
        return true;
    }
    else if (data.pair.whatstrat?.PANIC_SELL) {
        // keep status for pairs that get panic sold
        return true;
    }
    else {
        return false;
    }
})(this)